; LABYR v1.0 Beta
; by Alban Gervaise
; from the ti86 basic game "Labyrdingue"
; by Adrien Bernard
; written for Doorsos v1.0
; date: 1/07/99


        include "doorsos.h"
        include "userlib.h"
        include "graphlib.h"

        xdef _main
        xdef _ti89
        xdef _comment

X          = 13
Y          = 14
XNBR       = 22
YNBR       = 11

WAIT       = 20
BIG_WAIT   = 1000
STOP       = 12500

LEVEL_SIZE = XNBR*YNBR+4+1
LEVEL_NBR  = 5

mask0 equ %11111110  ;(up\2nd\donw...)
mask1 equ %11111101  ;(Enter\clear...)
mask3 equ %11110111  ;(catalog...)
mask4 equ %11101111  ;(Mode...)
mask5 equ %11011111  ;(Home...)
mask6 equ %10111111  ;(ESC...)


_main
        move.w #0,level
start
        bsr ini_board

        bsr ini_var
        bsr int_on
        

key_loop

        move.w wait,d0     ; on verifie si timer vaut wait
        cmp.w timer,d0
        ble verif          ; si oui alors on verifie

        tst.w stop         ; si stop n'est pas nul alors
        beq \saute         ; pas droit au pad
        sub.w #1,stop      ; on retanche 1
        bra key_loop       ; on repart pour un tour
\saute  
        clr.l d2
        clr.l d3
        move.w #mask0,d0
        bsr get_key
        btst.b #0,d0
        beq haut
        btst.b #3,d0
        beq droite
        btst.b #1,d0
        beq gauche
        btst.b #2,d0
        beq bas
        move.w #mask1,d0
        bsr get_key
        btst.b #6,d0
        beq restart
        btst.b #1,d0
        beq plus
        btst.b #2,d0
        beq moins
        move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        beq sure
        bra key_loop


restart bsr int_off
        bra start

plus    add.w #1,level
        cmp.w #LEVEL_NBR,level
        bne restart
moins   sub.w #1,level
        cmp.w #-1,level
        bne restart
        add.w #1,level
        bra restart



haut    btst.b #0,flag           ; si on saute deja alors on quitte
        bne key_loop
        btst.b #1,flag
        bne key_loop
        move.w #XNBR,d3      ; on verifie la case au dessus
        bsr check
        tst.w d0             ; si c'est pas bon alors on quitte
        bne key_loop
        bset.b #0,flag       ; si c'est bon on saute (1er partie du saut)
        bset.b #2,flag
        move.w #WAIT,wait    ; on modifie le temps d'attente
        bra key_loop         ; on revient



droite  btst.b #2,flag
        beq \apres
        bset.b #5,flag
        bclr.B #4,flag
        bra key_loop

\apres
        move.w #1,d2         ; on ajoute +1 pour avoir la case ou
        bsr check            ; on va, on verifie ce qu'il y a dedans
        tst.w d0             ; d0=0=>pas de problemes
        bne bas ; key_loop         ; sinon pas bon on revient
        bsr erase_cursor     ; on efface le curseur
        add.w #6,posx        ; on update sa position
        bsr draw_cursor      ; on le redessine
        bra bas              ; on verifie encore...

gauche  btst.b #2,flag
        beq \saute
        bclr.B #5,flag
        bset.b #4,flag
        bra key_loop
\saute
        move.w #1,d3
        bsr check
        tst.w d0
        bne bas
        bsr erase_cursor
        sub.w #6,posx
        bsr draw_cursor



bas     move.w #STOP,stop    ; on remet une valeur dans stop
        bset.b #2,flag
        bclr.b #4,flag
        bclr.b #5,flag

        bsr give_pos         ; on regarde ce qu'il y a en bas
        add.W #XNBR,a0
        tst.b (a0)           ; si pas 0
        bne stopl            ; alors on s'arrete
        bset.b #1,flag

        bra key_loop

stopl   bclr.b #1,flag
        bclr.b #2,flag

        bsr give_pos
        sub.w #XNBR,a0
        cmp.b #3,(a0)
        bne key_loop

ecrase
        move.w posx,d0
        move.w posy,d1
        sub.w #6,d1
        move.l #sprites,a0
        bsr draw_objet

        add.w #6,d1
        move.l #sprites+5*10,a0
        bsr draw_objet

        bsr int_off
dead    jsr userlib::idle_loop
        cmp.w #13,d0
        beq start
        cmp.w #264,d0
        beq exit
        bra dead


bingo   add.w #1,level
        cmp.w #LEVEL_NBR,level
        bne restart
        move.w #4,level
        bra restart


check   bsr give_pos
        move.l a0,a1
        add.w d2,a0
        sub.w d3,a0
        tst.b (a0)    ; si 0=rien c'est bon
        beq bon
        cmp.b #1,(a0) ; si 2=caisse pas bon
        beq exit

        move.l a0,a2
        add.w d2,a2
        sub.w d3,a2
        tst.B (a2)
        bne exit
        move.b #2,(a2)
        clr.b (a0)

        move.w posx,d0
        move.w posy,d1

        cmp.w #XNBR,d2
        beq \s1
        cmp.w #1,d2
        beq \s2
        cmp.w #XNBR,d3
        beq \s3
        move.w #-6,d2
        move.w #0,d3

\draw   clr.l d4
        move.b (a1),d4
        mulu #10,d4
        move.l #sprites,a0
        add.w d4,a0
        bsr draw_objet
        add.w d2,d0
        add.w d3,d1
        move.l #sprites,a0
        bsr draw_objet
        add.w d2,d0
        add.w d3,d1
        move.l #sprites+10*2,a0
        bsr draw_objet
        bra bon

\s1     clr.w d2
        move.w #6,d3        
        bra.s \draw
\s2     move.w #6,d2
        clr.w d3
        bra.s \draw
\s3     clr.w d2
        move.w #-6,d3
        bra.s \draw

bon     clr.w d0
        rts



verif
        clr.w timer

        bclr.b #6,flag

        move.l #board,a6        ; d'abord on verifie si il y a
        move.w #LEVEL_SIZE,d7          ; des blocs en l'air
        move.w #X+1,d0
        move.w #Y+1,d1
\loop   cmp.b #2,(a6)
        bne \passe
        tst.B XNBR(a6)
        bne \passe
        move.l #sprites,a0
        bsr draw_objet
        add.w #6,d1

        cmp.w posx,d0
        bne \go_on
        cmp.w posy,d1
        bne \go_on
        bset.B #6,flag
\go_on
        move.l #sprites+10*2,a0
        bsr draw_objet
        sub.w #6,d1
        move.b #2,XNBR(a6)
        clr.b (a6)


\passe  add.w #6,d0
        cmp.w #6*XNBR+X+1,d0
        bne \chg
        move.w #X+1,d0
        add.w #6,d1
\chg    add.l #1,a6
        dbra.S d7,\loop

        btst.B #6,flag
        bne ecrase

        move.w curx,d0
        cmp.w posx,d0
        bne \pasbon
        move.w cury,d0
        cmp.w posy,d0
        beq bingo
\pasbon

        btst.b #0,flag       ; si bit 0=1 alors on monte...
        bne \ok
        btst.b #1,flag       ; si bit 1=1 alors on descent
        beq key_loop

        bset.B #2,flag       ; pour l'instant on bouge plus

        move.w #WAIT,wait    ; on mais un temps normal
        bsr erase_cursor     ; on efface le curseur
        add.w #1,posy
        bsr draw_cursor      ; on le reaffiche

        clr.l d0
        move.w posy,d0
        sub.w #15,d0
        divu #6,d0
        swap d0
        tst.w d0
        bne key_loop         ; on regarde si on est sur un etage

        bclr.b #2,flag

        clr.w d3
        move.w #XNBR,d2      ; on regarde ce qu'il y a dessous
        bsr check
        tst.w d0
        beq key_loop         ; si on peut y aller alors on quitte

        and.b #%11001001,flag ; sinon on arrete de descendre
        bra key_loop


\ok     bsr erase_cursor      ; on efface le curseur
        sub.w #1,posy
        bsr draw_cursor       ; on le reaffciche

        clr.l d0              ; on verifie si on est sur l'etage
        move.w posy,d0        ; au dessus
        sub.w #15,d0          ; si non alors on change rien
        divu #6,d0
        swap d0
        tst.w d0
        bne key_loop     x


        move.w #WAIT,wait     ; on remet le delai normal

        bclr.b #2,flag        ; maintenant on peut bouger
        bclr.b #0,flag        ; si oui alors on arrete de monter

        btst.b #4,flag
        bne gauche
        btst.b #5,flag
        bne droite

        bset.b #1,flag

        move.w #WAIT,wait     ; on remet le delai normal
        move.w #XNBR,d2
        clr.w d3
        bsr check             ; on verifie ce qu'il y a audessous
        tst.w d0              ; si il y a quelque chose on s'arrete
        beq key_loop

        move.w #BIG_WAIT,wait ; sinon on repart avec un grand delai
        bra key_loop



get_key move.w  d0,$600018
        move.w #50,d0
delay_c dbra d0,delay_c
        move.b $60001b,d0
exit    rts


sure    move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        bne key_loop
        bra int_off


int_on  move.w #$0700,d0
        trap #1
        bclr.b #2,($600001)
        move.l ($64),old_int1
        move.l #new_int,($64)
        bset.b #2,($600001)
        trap #1
	rts
int_off move.w #$0700,d0
        trap #1
        bclr.b #2,($600001)
        move.l old_int1,($64)
        bset.b #2,($600001)
        trap #1
	rts
new_int add.w #1,timer
        rte

give_pos
        clr.l d1
        clr.l d0
        move.w posx,d0
        sub.w #X+1,d0
        divu #6,d0
        move.w posy,d1
        sub.w #Y+1,d1
        divu #6,d1
        mulu #XNBR,d1
        add.w d1,d0
        move.l #board,a0
        add.w d0,a0
        rts


ini_board
        jsr graphlib::clr_scr

        move.l #board,a1
        clr.l d0
        move.l #level0,a0
        move.w level,d0
        mulu #95,d0
        add.l d0,a0

        move.w #6,d3
        move.w #60,d7
loop_comp:
        move.b (a0),d0
        ror.b d3,d0
        and.b #%00000011,d0
        move.b d0,(a1)+
        cmp.w #2,d3
        beq ok_comp
        sub.w #2,d3
        bra loop_comp
ok_comp move.b (a0)+,d0
        and.b #%00000011,d0
        move.b d0,(a1)+
        move.w #6,d3
        dbra d7,loop_comp
        sub.l #2,a1
        move.b (a0)+,(a1)+
        move.b (a0)+,(a1)+
        move.b (a0)+,(a1)+
        move.b (a0)+,(a1)


;        move.l a0,-(a7)                ; pour l'instant on utilise pas le comment...
;        jsr doorsos::ST_showHelp       ;
;        lea 4(a7),a7                   ;

        move.b #0,level_str+8
        move.b level+1,d0
        add.b #49,d0
        move.b d0,level_str+8
        SetFont #0
        WriteStr #60,#85,#4,level_str
        clr.w -(a7)
        jsr doorsos::ST_busy
        lea 2(a7),a7
        WriteStr #42,#0,#4,_comment
        SetFont #1


        move.l #board,a6
        move.w #X+1,curx
        move.w #Y+1,cury
        move.w #YNBR-1,d6
\loopy  move.w #XNBR-1,d7
\loopx  move.b (a6)+,d0
        cmp.b #5,d0
        bne \saute
        move.b #2,d0
\saute  mulu #10,d0
        move.l #sprites,a0
        add.l d0,a0
        move.B #$FF,d3
        move.w curx,d0
        move.w cury,d1
        jsr graphlib::put_sprite_mask
        add.w #6,curx        
        dbra.s d7,\loopx
        move.w #X+1,curx
        add.w #6,cury
        dbra.s d6,\loopy
        move.b (a6)+,posx+1
        move.b (a6)+,posy+1
        clr.l curx
        move.b (a6)+,curx+1
        move.b (a6)+,cury+1


        move.w curx,d0
        move.w cury,d1
        move.l #sprites+4*10,a0
        move.l #mask2,a2
        jsr graphlib::put_sprite2
        bsr draw_cursor
;        move.w #X,d0
;        move.w #Y,d1
;        move.w #6*XNBR+1,d4
;        move.w #6*YNBR+1,d5
;        jsr graphlib::frame
        rts
draw_cursor
        move.w posx,d0
        move.w posy,d1
        move.l #cursor_sprite,a0
        move.l #mask,a2
        jsr graphlib::put_sprite2
        rts
erase_cursor
        move.w posx,d0
        move.w posy,d1
        move.l #sprites,a0
        move.l #mask,a2
        jsr graphlib::put_sprite2
        rts
draw_objet
        move.l #mask2,a2
        jsr graphlib::put_sprite2
        rts

ini_var clr.b flag
        clr.w timer
        clr.w stop
        move.w #WAIT,wait
        rts


sprites:

        dc.w 6
        dc.w 1
        dc.b %00000000
        dc.b %00000000
        dc.b %00000000
        dc.b %00000000
        dc.b %00000000
        dc.b %00000000

        dc.w 6
        dc.w 1
        dc.b %00000100
        dc.b %01011100
        dc.b %00101100
        dc.b %01011100
        dc.b %01111100
        dc.b %11111100

        dc.w 6
        dc.w 1
        dc.b %00000000
        dc.b %11111000
        dc.b %10101000
        dc.b %10101000
        dc.b %10101000
        dc.b %11111000

        dc.w 6
        dc.w 1
        dc.b %00100000
        dc.b %11111000
        dc.b %10101000
        dc.b %10101000
        dc.b %10101000
        dc.b %11111000

        dc.w 6
        dc.w 1
        dc.b %00000000
        dc.b %01001000
        dc.b %00000000
        dc.b %00000000
        dc.b %01001000
        dc.b %00000000

        dc.w 6
        dc.w 1
        dc.b %11111000
        dc.b %10101000
        dc.b %10101000
        dc.b %10101000
        dc.b %11111000
        dc.b %01110000


cursor_sprite
        dc.w 6
        dc.w 1
        dc.b %00000000
        dc.b %00110000
        dc.b %01111000
        dc.b %01111000
        dc.b %00110000
        dc.b %00000000


mask    dc.b %00000000
        dc.b %00110000
        dc.b %01111000
        dc.b %01111000
        dc.b %00110000
        dc.b %00000000

mask2   dc.b %11111100
        dc.b %11111100
        dc.b %11111100
        dc.b %11111100
        dc.b %11111100
        dc.b %11111100


level0
        dc.b %01010101,%01010101,%01010101,%01010101
        dc.b %01010101,%01010100,%10000000,%00000000
        dc.b %00100000,%00000000,%00000001,%01010100
        dc.b %00000001,%01010101,%00000000,%10001000
        dc.b %00010100,%00000010,%00010101,%01010100
        dc.b %00010101,%01010001,%01001000,%01010101
        dc.b %00100000,%00000101,%00000010,%00010101
        dc.b %01000100,%00000001,%00100001,%01000000
        dc.b %00010101,%01000000,%10000001,%01010001
        dc.b %01010000,%00100001,%01010100,%01000101
        dc.b %01001000,%00001000,%10000101,%00000001
        dc.b %01000100,%01010000,%01000100,%01000100
        dc.b %01010001,%00010100,%00000000,%00000100
        dc.b %00000100,%01010100,%00000001,%01010101
        dc.b %01010101,%01010101,%01010101,%01010101
        dc.b %01010000
        dc.b 20,21
        dc.b 116,69
        dc.b "Level 1 by Adrien Bernard    ",0

        dc.b %01010101,%01010101,%01010101,%01010101
        dc.b %01010101,%01010101,%01000000,%10000000
        dc.b %00001000,%00000000,%00000001,%01010000
        dc.b %00000101,%00000000,%10000100,%10000101
        dc.b %01010100,%00000001,%00100001,%01010100
        dc.b %01010100,%00000001,%01000000,%01000001
        dc.b %00000010,%00000100,%10001000,%00010100
        dc.b %10000000,%00001000,%00100001,%00000100
        dc.b %01010001,%01000101,%00000100,%10000101
        dc.b %00001000,%00010100,%00010100,%10000100
        dc.b %00010100,%00000000,%01001000,%00000101
        dc.b %01010100,%10000000,%00000000,%01010101
        dc.b %01010000,%00010101,%01000101,%00000000
        dc.b %10000000,%10000000,%00000001,%01010101
        dc.b %01010101,%01010101,%01010101,%01010101
        dc.b %01010000
        dc.b 62,39
        dc.b 134,21
        dc.b "Level 2 by Adrien Bernard    ",0

        dc.b %01010101,%01010101,%01010101,%01010101
        dc.b %01010101,%01010100,%00000000,%00010100
        dc.b %00001100,%00000000,%00000001,%01010100
        dc.b %00000011,%00000000,%00000001,%00000101
        dc.b %00010100,%00001000,%00000001,%00010100
        dc.b %01010001,%00110001,%01000000,%01010001
        dc.b %00000011,%01000100,%00000000,%00010100
        dc.b %00001000,%00010100,%00000000,%01000000
        dc.b %00010101,%01010101,%01001000,%00000001
        dc.b %01000100,%01000011,%00010100,%00000100
        dc.b %10000001,%01010100,%00000100,%01000001
        dc.b %01000000,%11000101,%00000011,%00000100
        dc.b %01000111,%00010100,%00000000,%00000010
        dc.b %00000000,%01001000,%00000001,%01010101
        dc.b %01010101,%01010101,%01010101,%01010101
        dc.b %01010000
        dc.b 74,51
        dc.b 86,45
        dc.b "Level 3 by Adrien Bernard    ",0

        dc.b %01010101,%01010101,%01010101,%01010101
        dc.b %01010101,%01010100,%00001000,%00000000
        dc.b %00110011,%00000000,%00000001,%01000000
        dc.b %01000000,%00010000,%00000001,%00000010
        dc.b %00010100,%01000000,%10001000,%01000100
        dc.b %00000000,%00100001,%01001000,%01010101
        dc.b %01000000,%00000000,%00010101,%00010100
        dc.b %10000100,%10000000,%01010101,%01010000
        dc.b %00010001,%01001000,%00000100,%00010100
        dc.b %00000001,%00100000,%00010100,%01000001
        dc.b %01000001,%00000000,%00100001,%00000001
        dc.b %01000000,%00001101,%00110001,%01000001
        dc.b %01000010,%00010100,%00000100,%00000000
        dc.b %00000000,%00000000,%00010101,%01010101
        dc.b %01010101,%01010101,%01010101,%01010101
        dc.b %01010000
        dc.b 56,33
        dc.b 104,21
        dc.b "Level 4 by Adrien Bernard    ",0

        dc.b %01010101,%01010101,%01010101,%01010101
        dc.b %01010101,%01010100,%00000000,%01000000
        dc.b %00010101,%01000000,%00000001,%01010100
        dc.b %00001100,%01000000,%00001000,%00000001
        dc.b %00010100,%00000100,%00000000,%00000000
        dc.b %01000100,%01000001,%01001000,%00000101
        dc.b %00000001,%00100000,%00000100,%00010100
        dc.b %01010000,%00110000,%00000001,%00010100
        dc.b %00000101,%01001000,%01000000,%00001000
        dc.b %01000010,%00010010,%00010101,%01000000
        dc.b %01010101,%01000000,%01010000,%00010001
        dc.b %01110000,%00010000,%00001100,%01010100
        dc.b %00010100,%00010100,%00000000,%00000000
        dc.b %00000000,%00000010,%00000001,%01010101
        dc.b %01010101,%01010101,%01010101,%01010101
        dc.b %01010000
        dc.b 20,69
        dc.b 134,39
        dc.b "Level 5 by Adrien Bernard    ",0

old_int1 dc.l 0

curx  dc.w 0
cury  dc.w 0
posx  dc.w 0
posy  dc.w 0
flag  dc.b 0
wait  dc.w 0
timer dc.w 0
stop  dc.w 0
level dc.w 0

level_str dc.b "- Level x -",0

_comment dc.b "Labyr v1.0",129," by Endive",0

 BSS

board   ds.b LEVEL_SIZE

 end

